# IWorkingBoxPlane Struct Reference
[External Interfaces]

Inheritance diagram for IWorkingBoxPlane:

List of all members.

## Public Member Functions
virtual const TTransform3D &MCCOMAPI | GetTransform ()=0
virtual const TPlane *MCCOMAPI | GetPlane () const =0
virtual void MCCOMAPI | SetTransform (const TTransform3D &transform)=0
virtual TVector2 MCCOMAPI | ConstrainDirections (const TVector2 &inOldHit, const TVector2 &inNewHit) const =0
virtual TVector2 MCCOMAPI | SnapVector (const TVector2 &inOldHit, const TVector2 &inNewHit) const =0
virtual TVector2 MCCOMAPI | SnapPoint (const TVector2 &inWhere) const =0
virtual void MCCOMAPI | GetMinMax (TVector2 &outMin, TVector2 &outMax)=0
virtual void MCCOMAPI | GetDelta (TVector2 &outDelta)=0
virtual int32 MCCOMAPI | GetSpacing () const =0
virtual boolean MCCOMAPI | GetDrawGrid () const =0
virtual boolean MCCOMAPI | GetDrawCentered () const =0
virtual boolean MCCOMAPI | GetDrawOutline () const =0
virtual void MCCOMAPI | GetDrawOutlineSide (boolean &outDrawLeft, boolean &outDrawRight, boolean &outDrawTop, boolean &outDrawBottom)=0
virtual TMCColorRGBA MCCOMAPI | GetGridColor () const =0
virtual TMCColorRGBA MCCOMAPI | GetOutlineColor () const =0
virtual void MCCOMAPI | GetPlaneVectors (TVector3 &ii, TVector3 &jj, TVector3 &kk, TVector3 &oo, boolean global)=0
virtual void MCCOMAPI | SetMinMax (const TVector2 &inMin, const TVector2 &inMax)=0
virtual void MCCOMAPI | SetDelta (const TVector2 &inDelta)=0
virtual void MCCOMAPI | SetSpacing (int32 inSpacing)=0
virtual void MCCOMAPI | SetDrawGrid (boolean inDrawGrid)=0
virtual void MCCOMAPI | SetDrawCentered (boolean inDrawCentered)=0
virtual void MCCOMAPI | SetDrawOutline (boolean inDrawOutline)=0
virtual void MCCOMAPI | SetDrawOutlineSide (boolean inDrawLeft, boolean inDrawRight, boolean inDrawTop, boolean inDrawBottom)=0
virtual void MCCOMAPI | SetDrawAll (boolean inDraw)=0
virtual void MCCOMAPI | SetGridColor (const TMCColorRGBA &color)=0
virtual void MCCOMAPI | SetOutlineColor (const TMCColorRGBA &color)=0
virtual void MCCOMAPI | AddRenderables (TRenderableAndTfmArray &outRenderables)=0
virtual void MCCOMAPI | InvalidateRenderables ()=0
virtual void MCCOMAPI | SetPlaneImageWithPathName (const TMCString &filePath)=0
| Create an image attached to the working plane based on an image file path.
virtual void MCCOMAPI | SetPlaneImage (IShRasterLayer *rasterLayer)=0
| Create an image attached to the working plane based on a raster layer.
virtual IShRasterLayer *MCCOMAPI | GetPlaneImageNoAddRef ()=0
| Return a pointer to an image attached to this plane.
virtual void MCCOMAPI | ActivatePlaneImage (boolean active)=0
| Activate or deactivate the use of the image attached to the working plane.
virtual boolean MCCOMAPI | IsPlaneImageActive ()=0

## Detailed Description

A Working Box Plane is a plane of a Working Box.

The location and orientation of a Working Box Plane is defined by a TTreeTransform, but you can get a TPlane for your convenience if you wish.

You will probably never need to set individually the transformation of the 3 first planes of a Working Box. The Working Box takes care of it for you, use IWorkingBox::SetTreeTransform(). IWorkingBoxPlane::SetTreeTransform() is generally used only for setting the position and orientation of the "Extra Plane" (the 4th one).

## Member Function Documentation

virtual void MCCOMAPI IWorkingBoxPlane::ActivatePlaneImage | ( | boolean | active | ) | `[pure virtual]`

Activate or deactivate the use of the image attached to the working plane.

virtual void MCCOMAPI IWorkingBoxPlane::AddRenderables | ( | TRenderableAndTfmArray & | outRenderables | ) | `[pure virtual]`

virtual TVector2 MCCOMAPI IWorkingBoxPlane::ConstrainDirections | ( | const TVector2 & | inOldHit,
|  | const TVector2 & | inNewHit |
| ) |  |  | const`[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::GetDelta | ( | TVector2 & | outDelta | ) | `[pure virtual]`

virtual boolean MCCOMAPI IWorkingBoxPlane::GetDrawCentered | ( |  | ) | const`[pure virtual]`

virtual boolean MCCOMAPI IWorkingBoxPlane::GetDrawGrid | ( |  | ) | const`[pure virtual]`

virtual boolean MCCOMAPI IWorkingBoxPlane::GetDrawOutline | ( |  | ) | const`[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::GetDrawOutlineSide | ( | boolean & | outDrawLeft,
|  | boolean & | outDrawRight,
|  | boolean & | outDrawTop,
|  | boolean & | outDrawBottom |
| ) |  |  | `[pure virtual]`

virtual TMCColorRGBA MCCOMAPI IWorkingBoxPlane::GetGridColor | ( |  | ) | const`[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::GetMinMax | ( | TVector2 & | outMin,
|  | TVector2 & | outMax |
| ) |  |  | `[pure virtual]`

virtual TMCColorRGBA MCCOMAPI IWorkingBoxPlane::GetOutlineColor | ( |  | ) | const`[pure virtual]`

virtual const TPlane* MCCOMAPI IWorkingBoxPlane::GetPlane | ( |  | ) | const`[pure virtual]`

virtual IShRasterLayer* MCCOMAPI IWorkingBoxPlane::GetPlaneImageNoAddRef | ( |  | ) | `[pure virtual]`

Return a pointer to an image attached to this plane.

virtual void MCCOMAPI IWorkingBoxPlane::GetPlaneVectors | ( | TVector3 & | ii,
|  | TVector3 & | jj,
|  | TVector3 & | kk,
|  | TVector3 & | oo,
|  | boolean | global |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI IWorkingBoxPlane::GetSpacing | ( |  | ) | const`[pure virtual]`

virtual const TTransform3D& MCCOMAPI IWorkingBoxPlane::GetTransform | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::InvalidateRenderables | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI IWorkingBoxPlane::IsPlaneImageActive | ( |  | ) | `[pure virtual]`

Returns:
  true if the image attached to this plane is active, false oherwise. This flag does not guarantee that an image is actually attached to the plane.

virtual void MCCOMAPI IWorkingBoxPlane::SetDelta | ( | const TVector2 & | inDelta | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetDrawAll | ( | boolean | inDraw | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetDrawCentered | ( | boolean | inDrawCentered | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetDrawGrid | ( | boolean | inDrawGrid | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetDrawOutline | ( | boolean | inDrawOutline | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetDrawOutlineSide | ( | boolean | inDrawLeft,
|  | boolean | inDrawRight,
|  | boolean | inDrawTop,
|  | boolean | inDrawBottom |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetGridColor | ( | const TMCColorRGBA & | color | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetMinMax | ( | const TVector2 & | inMin,
|  | const TVector2 & | inMax |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetOutlineColor | ( | const TMCColorRGBA & | color | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetPlaneImage | ( | IShRasterLayer * | rasterLayer | ) | `[pure virtual]`

Create an image attached to the working plane based on a raster layer.

virtual void MCCOMAPI IWorkingBoxPlane::SetPlaneImageWithPathName | ( | const TMCString & | filePath | ) | `[pure virtual]`

Create an image attached to the working plane based on an image file path.

virtual void MCCOMAPI IWorkingBoxPlane::SetSpacing | ( | int32 | inSpacing | ) | `[pure virtual]`

virtual void MCCOMAPI IWorkingBoxPlane::SetTransform | ( | const TTransform3D & | transform | ) | `[pure virtual]`

virtual TVector2 MCCOMAPI IWorkingBoxPlane::SnapPoint | ( | const TVector2 & | inWhere | ) | const`[pure virtual]`

virtual TVector2 MCCOMAPI IWorkingBoxPlane::SnapVector | ( | const TVector2 & | inOldHit,
|  | const TVector2 & | inNewHit |
| ) |  |  | const`[pure virtual]`

The documentation for this struct was generated from the following file:

- IWorkingBox.h